<?php
/*
 * index.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * ------------------------------------------------------------
 */

include 'init/initialize.php';
ob_start();

switch($sub) {

  # --------------
  # normal classes
  # --------------

  case  'news':
  {
      include 'modules/news/inc.News.php';
      new news($db,$smarty,$cfg['news']);
      break;
  }
  case  'users':
      include 'modules/users/inc.Users.php';
      new users($db,$smarty);
      break;
      
  case  'members':
      include 'modules/members/inc.Members.php';
      new members($db,$smarty);
      break;
      
  case 'replays':
      include 'modules/replays/replays.php';
      break;
      
  case 'download':
      include 'modules/replays/download.php';
      break;
      
  case 'replays_ocena':
      include 'modules/replays/replays_review.php';
      break;
      
  default:
      $smarty->display('default.tpl');
  
}

if (error_reporting() == -1) {
	echo '<div style="text-align: center;">error_reporting = -1</div>';
}

?>
