#-----------#
# clan wars #
#-----------#

create table `mgc_clanwars` (
 cwid int not null auto_increment,
 title varchar(50) not null default '',
 enemy varchar(20) not null default '',
 flag varchar(50) not null default '',
 time varchar(14) not null default '0',
 index time (time),
 primary key (cwid)
)  type=myisam charset=latin2;

create table `mgc_clanwars_games` (
 gid int not null auto_increment,
 cwid int not null default '0',
 type varchar(3) not null default '',
 pts1 int not null default '0',
 epts1 int not null default '0',
 p1 varchar(20) not null default '',
 pid1 int not null default '0',
 p2 varchar(20) not null default '',
 pid2 int not null default '0',
 p3 varchar(20) not null default '',
 pid3 int not null default '0',
 p4 varchar(20) not null default '',
 pid4 int not null default '0',
 ep1 varchar(20) not null default '',
 ep2 varchar(20) not null default '',
 ep3 varchar(20) not null default '',
 ep4 varchar(20) not null default '',
 index pid1 (pid1),
 index pid2 (pid2),
 index pid3 (pid3),
 index pid4 (pid4),
 index cwid (cwid),
 primary key (gid)
)  type=myisam charset=latin2;

create table `mgc_clanwars_players` (
 pid int not null auto_increment,
 nick varchar(20) not null default '',
 status tinyint(1) not null default '0',
 description varchar(25) not null default '',
 games int not null default '0',
 win1v1 int not null default '0',
 win2v2 int not null default '0',
 win3v3 int not null default '0',
 win4v4 int not null default '0',
 loss1v1 int not null default '0',
 loss2v2 int not null default '0',
 loss3v3 int not null default '0',
 loss4v4 int not null default '0',
 primary key (pid)
)  type=myisam charset=latin2;

