<?php
/*
 * modules/members/inc.Members.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class members {
 var $db;
 var $smarty;
 
 var $mid;

 var $tbl_leaders  = array();
 var $tbl_active   = array();
 var $tbl_inactive = array();
 var $tbl_profile  = array();
 
 var $photo_url = '';
 var $photo_width = 0;
 var $photo_height = 0;

 function members($db,$smarty)
 {
   $this->db     = &$db;
   $this->smarty = &$smarty;
   
   $this->mid = (int) get_param('mid');

   #-- get
   $this->get_members();
   if($this->mid) $this->get_profile();

   #-- var
   $this->smarty->assign_by_ref('tbl_leaders', $this->tbl_leaders);
   $this->smarty->assign_by_ref('tbl_active', $this->tbl_active);
   $this->smarty->assign_by_ref('tbl_inactive', $this->tbl_inactive);
   $this->smarty->assign_by_ref('tbl_profile', $this->tbl_profile);

   $this->smarty->assign_by_ref('mid', $this->mid);

   $this->smarty->assign_by_ref('photo_url', $this->photo_url);
   $this->smarty->assign_by_ref('photo_width', $this->photo_width);
   $this->smarty->assign_by_ref('photo_height', $this->photo_height);
   
   #-- display
   $this->smarty->display('members/members.tpl');
   
 } //end func
 

 function get_members()
 {
   $this->db->query("select mid,nick,mstatus from ".prefix."members order by mstatus desc,nick");
   while($this->db->next_record())
   {
     switch($this->db->Record['mstatus'])
     {
       case '2':  $this->tbl_leaders[]  = $this->db->Record;  break;
       case '1':  $this->tbl_active[]   = $this->db->Record;  break;
       case '0':  $this->tbl_inactive[] = $this->db->Record;  break;
     }
   }
 } //end func
 
 function get_profile()
 {
   $this->db->query("select * from ".prefix."members where mid='{$this->mid}'");
   if($this->db->num_rows() != 1) { $this->mid = 0; return 0; }
   $this->db->next_record();
   $this->tbl_profile = $this->db->Record;
   
   #-- photo
   $this->get_photo();
 } //end func
 
 function get_photo()
 {
   $dir = $GLOBALS['cfg']['members_dir'];
   $ext = (array) $GLOBALS['cfg']['members_ext'];
   
   foreach($ext as $key=>$value)
   {
     $url = $dir . $this->mid . $value;
     if(file_exists($url)) $this->photo_url = $url;
   }
   if(!$this->photo_url) return 0;
   
   #-- width and height
   $img = getimagesize($this->photo_url);
   $this->photo_width  = $img[0];
   $this->photo_height = $img[1];

 } //end func
 
} //end class
?>
